/*
   Web-server that calculate table of NOD(a, b).
   Maded by Serebryakov-Ozerov-Nerobeeva-Golaiko Team.
*/

#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>

#define IP_ADDR "192.168.0.3"
#define PORT 45454

int nod(int a, int b)
{
    while ((a > 0) && (b > 0))
    {
        if (a > b) a %= b;
	else       b %= a;
    }
    return (a == 0) ? b : a;
}

void write_page(int cli_s, int n)
{
    const char *col[] = {
        "bgcolor=\"#dddddd\"",
        "bgcolor=\"#eeeeee\"",
        "bgcolor=\"#bbbbbb\"",
        "bgcolor=\"#cccccc\""
    };

    char strbuf[2000];

    if ((n < 1) || (n > 100)) // if wrong number or too big
    {
        sprintf(strbuf, "Too small or too big number: %i\n\n", n);
        write(cli_s, strbuf, strlen(strbuf));
        return;
    }

    sprintf(strbuf, "<html><body><center>"
                    "<table width=\"100%%\" border=\"1\" "
                    "style=\"border-collapse:collapse; text-align:center\">\n"
                    "<tr %s><td>NOD</td>", col[2]);
    write(cli_s, strbuf, strlen(strbuf));

    int i, j, p = 100/(n+1);

    for (j = 1; j <= n; j++)
    {
        sprintf(strbuf, "<td width=\"%i%%\">%i</td>", p, j);
        write(cli_s, strbuf, strlen(strbuf));
    }

    for (i = 1; i <= n; i++)
    {
        sprintf(strbuf, "</tr>\n<tr %s><td %s width=\"%i%%\">%i</td>", col[i%2], col[2+i%2], p, i);
        write(cli_s, strbuf, strlen(strbuf));

        for (j = 1; j <= n; j++)
        {
            sprintf(strbuf, "<td>%i</td>", nod(i, j));
            write(cli_s, strbuf, strlen(strbuf));
        }
    }

    sprintf(strbuf, "</tr>\n</table></center></body></html>\n");
    write(cli_s, strbuf, strlen(strbuf));
}

int findname(char *str, char *name, int *n)
{
    char *tempstr = str;
    char *tempname = name;
    while (*tempstr != ' ') tempstr++;
    tempstr += 2;
    while (*tempstr != ' ')
    {
        *tempname = *tempstr;
        tempstr++;
        tempname++;
    }
    tempname = '\0';
    return ( sscanf(name, "%i", n) == 1 );
}


int main()
{
    int h_s, client, inc;
    struct sockaddr_in s_in;

    h_s = socket(AF_INET, SOCK_STREAM, 0);

    s_in.sin_family = AF_INET;
    s_in.sin_port = htons(PORT);
    s_in.sin_addr.s_addr = inet_addr(IP_ADDR);

    inc = 0;
    while ( bind(h_s, (struct sockaddr *)&s_in, sizeof(s_in)) != 0 )
    {
        inc++;
        printf("Port %i is busy... %i sec\n", PORT, inc);
        sleep(1);
    }
    printf("Binded with %i port\n", PORT);

    inc = 0;
    while ( listen(h_s, 5) != 0 )
    {
        inc++;
        printf("Can't listen... %i sec\n", inc);
        sleep(1);
    }
    printf("Vse pravoe!\n");

    while (1)
    {
        printf("Listening at %s:%i\n\n", IP_ADDR, PORT);

        int size = 0;
        client = accept(h_s, (struct sockaddr *)&s_in, &size);

        char request[1200] = { 0 };
        char fname[255] = { 0 };
        int n = 0;

        read(client, request, sizeof(request));
        printf("%s", request);

        if ( findname(request, fname, &n) )
        {
            printf("%s\n", fname);
            write_page(client, n); // if success
        }
        else
        {
            char buff[1000];
            sprintf(buff, "Error request: \"%s\"\n\n", fname);
            printf(buff);
            write(client, buff, strlen(buff)); // if error
        }

        close(client);
    }

    return 0;
}
